<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_OfferSupplementType ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_OfferSupplementType extends AbstractStructArrayBase
{
    /**
     * The OfferSupplementType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_OfferSupplementType[]
     */
    public $OfferSupplementType;
    /**
     * Constructor method for ArrayOfJP_OfferSupplementType
     * @uses ArrayOfJP_OfferSupplementType::setOfferSupplementType()
     * @param \StructType\JP_OfferSupplementType[] $offerSupplementType
     */
    public function __construct(array $offerSupplementType = array())
    {
        $this
            ->setOfferSupplementType($offerSupplementType);
    }
    /**
     * Get OfferSupplementType value
     * @return \StructType\JP_OfferSupplementType[]|null
     */
    public function getOfferSupplementType()
    {
        return $this->OfferSupplementType;
    }
    /**
     * This method is responsible for validating the values passed to the setOfferSupplementType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOfferSupplementType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOfferSupplementTypeForArrayConstraintsFromSetOfferSupplementType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_OfferSupplementTypeOfferSupplementTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_OfferSupplementTypeOfferSupplementTypeItem instanceof \StructType\JP_OfferSupplementType) {
                $invalidValues[] = is_object($arrayOfJP_OfferSupplementTypeOfferSupplementTypeItem) ? get_class($arrayOfJP_OfferSupplementTypeOfferSupplementTypeItem) : sprintf('%s(%s)', gettype($arrayOfJP_OfferSupplementTypeOfferSupplementTypeItem), var_export($arrayOfJP_OfferSupplementTypeOfferSupplementTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OfferSupplementType property can only contain items of type \StructType\JP_OfferSupplementType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OfferSupplementType value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_OfferSupplementType[] $offerSupplementType
     * @return \ArrayType\ArrayOfJP_OfferSupplementType
     */
    public function setOfferSupplementType(array $offerSupplementType = array())
    {
        // validation for constraint: array
        if ('' !== ($offerSupplementTypeArrayErrorMessage = self::validateOfferSupplementTypeForArrayConstraintsFromSetOfferSupplementType($offerSupplementType))) {
            throw new \InvalidArgumentException($offerSupplementTypeArrayErrorMessage, __LINE__);
        }
        $this->OfferSupplementType = $offerSupplementType;
        return $this;
    }
    /**
     * Add item to OfferSupplementType value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_OfferSupplementType $item
     * @return \ArrayType\ArrayOfJP_OfferSupplementType
     */
    public function addToOfferSupplementType(\StructType\JP_OfferSupplementType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_OfferSupplementType) {
            throw new \InvalidArgumentException(sprintf('The OfferSupplementType property can only contain items of type \StructType\JP_OfferSupplementType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OfferSupplementType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_OfferSupplementType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_OfferSupplementType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_OfferSupplementType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_OfferSupplementType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_OfferSupplementType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OfferSupplementType
     */
    public function getAttributeName()
    {
        return 'OfferSupplementType';
    }
}
